﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace HighVoltz.AutoAngler
{
	static partial class Coroutines
	{
		private readonly static WaitTimer BaitRecastTimer = WaitTimer.TenSeconds;

		private static readonly Dictionary<uint, string> Baits = new Dictionary<uint, string>
																{
																	{110291, "Fire Ammonite Bait"},
																	{110290, "Blind Lake Sturgeon Bait"},
																	{110292, "Sea Scorpion Bait"},
																	{110274, "Jawless Skulker Bait"},
																	{110293, "Abyssal Gulper Eel Bait"},
																	{110289, "Fat Sleeper Bait"},
																	{110294, "Blackwater Whiptail Bait"},
																	{114628, "Icespine Stinger Bait"},
																	{114874, "Moonshell Claw Bait"},
																};

		// does nothing if no Baits are in bag
		public async static Task<bool> ApplyBait()
		{
			if (StyxWoW.Me.IsCasting || IsBaitBuffed)
				return false;

			if (!BaitRecastTimer.IsFinished)
				return false;
			
			BaitRecastTimer.Reset();

			foreach (var kv in Baits)
			{
				WoWItem BaitInBag = Utility.GetItemInBag(kv.Key);
				if (BaitInBag != null && BaitInBag.Use())
				{
					AutoAnglerBot.Log("Appling {0}", kv.Value);
					await CommonCoroutines.SleepForLagDuration();
					return true;
				}
			}
			return false;
		}

		public static bool IsBaitBuffed
		{
			get
			{
				foreach (var kv in Baits)
			    {
				  if (Me.HasAura(kv.Value)) { return true; }				
				}
			  return false;	
			}             			
		}
	}
}
